/**
 * This program has been developed by students from the bachelor Computer Science at
 * Utrecht University within the Software Project course.
 * © Copyright Utrecht University (Department of Information and Computing Sciences)
 */

/** Types for the nodes and links in the node-link diagram. */
export type GraphType = {
  nodes: Record<string, NodeType>;
  edges: Record<string, EdgeType>;
};

export type NodeType = d3.SimulationNodeDatum & {
  id: string; // uuid
  ids: string[]; // reverse mapping to original _id
  color: number;
  label?: string;
  radius?: number;
  alpha?: number;
};

export type EdgeType = d3.SimulationLinkDatum<NodeType> & {
  id: string; // uuid
  ids: string[]; // reverse mapping to original _id
  label?: string;
  thickness: number;
  color: number;
  alpha?: number;
  style: number;
};
